void SetRaceSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int name, prob, size, attack, scriptpos, valcount;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		prob = GetValNumber(Vals, "Prob", Number);
		size = GetValNumber(Vals, "Size", Number);
		attack = GetValNumber(Vals, "AttackType", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		valcount = Number;
		return;
	}
		
	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in Race Source Database\n");
		quitprog();
	}

	strcpy(((clsRace*) TargetStruct)->Name, Vals[name]);
	sscanf(Vals[prob], "%d", &(((clsRace*) TargetStruct)->Probability));	
	sscanf(Vals[size], "%d", &(((clsRace*) TargetStruct)->Size));	
	sscanf(Vals[attack], "%d", &(((clsRace*) TargetStruct)->PreferedAttackType));

	if (bnf::bnfparse(Vals[scriptpos], &(((clsRace*) TargetStruct)->Script)))
	{
		printf("Error in Character Script %s\n", Vals[name]);
		quitprog();
	}
}

int GetRaceNumber(char* RaceName)
{
	int i;
	for (i = 0;i < Source.RaceSourceCount;i++)
	{
		if (strcmp(RaceName, Source.RaceSource[i].Name) == 0)
		{
			return(i);
		}
	}
	printf("Race not found(%s)\n", RaceName);
	quitprog();
	return(0);
}

int RaceSourceInit()
{
	int i;
	FILE *fChar;

	if (DebugOutput) {printf("Opening Race List (%s)\t\t\t", RaceFile);}
	fChar = fopen(RaceFile, "r");
	if (fChar == 0)
	{
		printf("FAILED\n");
		return(1);
	}
	if (DebugOutput) {printf("OK\nReading Race List\t\t\t\t");}
	ProcessLine(fChar, &SetRaceSource, NULL, true);
	Source.RaceSourceCount = CountSetLines(fChar);
	if (DebugOutput) {printf("%d\n", Source.RaceSourceCount);}
	Source.RaceSource = new clsRace[Source.RaceSourceCount + 1];
	if (Source.RaceSource == 0)
	{
		printf("Memmory Allocation Error...\n");
		fclose(fChar);
		return(1);
	}
	if (DebugOutput) {printf("\t( ");}

	for (i = 0;i < Source.RaceSourceCount;i++)
	{
		ProcessLine(fChar, &SetRaceSource, &Source.RaceSource[i], false);
		if (DebugOutput) {printf("%s ", Source.RaceSource[i].Name);}
	}
	strcpy(Source.RaceSource[Source.RaceSourceCount].Name, "Monster");
	Source.RaceSource[Source.RaceSourceCount].PreferedAttackType = 1;
	Source.RaceSource[Source.RaceSourceCount].Probability = 0;
	Source.RaceSource[Source.RaceSourceCount].Size = 0;

	if (DebugOutput) {printf(")\n");}
	if (DebugOutput) {printf("\n");}

	fclose(fChar);

	return(0);
}

void RaceSourceExit()
{
	int i;
	for (i = 0;i < Source.RaceSourceCount;i++)
	{
		free(Source.RaceSource[i].Script);
	}
	delete[] Source.RaceSource;
}