void SetSkillSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i;
	static int ClassPosition[128];
	static int name, attr, valcount;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name, Number);
		}
		name = GetValNumber(Vals, "Name", Number);
		attr = GetValNumber(Vals, "Attr", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in SkillSource Database\n");
		quitprog();
	}

	strcpy(((clsSkills*) TargetStruct)->Name, Vals[name]);
	sscanf(Vals[attr], "%d", &(((clsSkills*) TargetStruct)->Attr));
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		sscanf(Vals[ClassPosition[i]], "%d", &(((clsSkills*) TargetStruct)->Prob[i]));
	}
}

int GetSkillNumber(char* SkillName, int uncomplete = 0)
{
	int i;
	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		if (strcmp(SkillName, Source.SkillSource[i].Name) == 0)
		{
			return(i);
		}
		if (uncomplete == 1 && strstr(Source.SkillSource[i].Name, SkillName) != 0)
		{
			return(i);
		}
	}
	printf("Skill not found(%s)\n", SkillName);
	quitprog();
	return(0);
}

int SkillSourceInit()
{
	int i;
	FILE* fChar;

	if (DebugOutput) {printf("Opening Skill List (%s)\t\t\t", SkillFile);}
	fChar = fopen(SkillFile, "r");
	if (fChar == 0)
	{
		printf("FAILED\n");
		return(1);
	}
	if (DebugOutput) {printf("OK\nReading Skill List\t\t\t\t");}
	ProcessLine(fChar, &SetSkillSource, NULL, true);
	Source.SkillSourceCount = CountSetLines(fChar);
	if (DebugOutput) {printf("%d\n", Source.SkillSourceCount);}
	Source.SkillSource = new clsSkills[Source.SkillSourceCount];
	if (Source.SkillSource == 0)
	{
		printf("Memmory Allocation Error...\n");
		fclose(fChar);
		return(1);
	}
	if (DebugOutput) {printf("\t( ");}

	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		ProcessLine(fChar, &SetSkillSource, &Source.SkillSource[i], false);
		if (DebugOutput) {printf("%s ", Source.SkillSource[i].Name);}
	}
	if (DebugOutput) {printf(")\n");}
	if (DebugOutput) {printf("\n");}

	fclose(fChar);

	return(0);
}

void SkillSourceExit()
{
	delete[] Source.SkillSource;
}