#define CharFile "Characters.txt"
#define FeatFile "Feats.txt"
#define SkillFile "Skills.txt"
#define EquipFile "Equipment.txt"
#define RaceFile "Races.txt"
#define WProbFile "Weapons.txt"
#define SpellFile "Spells.txt"
#define PowerFile "Powers.txt"
#define EffectFile "Effects.txt"
#define MonsterFile "Monsters.txt"
#define ProfileFile ".\\Profiles.txt"

#define SpellNone -1
#define SpellSorcerer 0
#define SpellWizard 1
#define SpellCleric 2
#define SpellDruid 3
#define SpellBarde 4
#define SpellPaladin 5
#define SpellRanger 6
#define SpellAssassin 7
#define SpellBlackGuard 8

#include "classes.h"
char tempstring[1024];
char tempout[16384];
char tempout2[16384];
char tempout3[16384];
char tempout4[16384];

CharTemplate CTtmp;

unsigned char Colour[1024];

void AddFeat(clsChar* TargetStruct, char* FeatName, int* featsyet, int Dep = -2);
int AdvancedRand(int number, int* firstval, int jump, char* Text, int TextJump, char* Text2, int OverrideManual);
int asc(char* ka);
void CalcMods(clsChar* TargetStruct);
void ChangeChar(clsChar* TargetStruct, int i);
void CharSourceExit();
int CharSourceInit();
bool CheckReq(clsChar* TargetStruct, int FeatNumber, int featsyet, char* ReqStr, int curlevel = 0);
void ClearChar(clsChar* TargetStruct);
int CountSetLines(FILE* fFile);
void DoLich(clsChar* TargetStruct);
void DoMonsterDesc(clsChar* TargetStruct, char* FileName);
void DoVampire(clsChar* TargetStruct);
bool FeatPresent(clsChar* TargetStruct, int FeatNumber, int featsyet, int FeatDep = -2);
char* GetAttributeName(int Number);
int GetMonsterTypeNumber(char* MonsterType);
int GetSizeNumber(char* Size);
int HighestVal(int* Array, int Number);
unsigned int hoch(unsigned int base, unsigned int exp);
unsigned int intpart(unsigned int val, unsigned int part);
void isaacinitrand(unsigned long* seed, bool randomdoseed = true);
void MixChar(clsChar* TargetStruct);
void ProcessLine(FILE *fFile, void (*ProcessFunction)(char* Vals[32], void* TargetStruct, int Number, bool header), void* TargetStruct, bool header);
void RandAttributes(clsChar* TargetStruct, int type);
void RandClass(clsChar* TargetStruct, int type, int multiclass, int* finished);
unsigned int random(int min, int max, char* Text, int OverrideManual);
int run();
void SetConsole(int Num, int Set = 1);
void SetCharSource(char** Vals, void* TargetStruct);
void SetFeatSkills(clsChar* TargetStruct);
void SourceExit();
int SourceInit();
int SummarizeArray(int* Array, int Number);

int manual = 0;
int manual2;
int DebugOutput = 0;

int worktype;
bool UseIsaac = false;

CharTemplate reheader;
int reproduce = 1, reproduceisaac = 0;
int readreproduce = 0, readreproducea = 0;

int InitPassed = 0;

unsigned int* retemp;
unsigned int* prepos;

FILE* reRead;

int loop = 0;
int loopdisplay = 1;
int adverror = 1;
int DummyChar = 0;
clsChar* dummySource;

int randstackinit = 0;
int randstacktmp;
int randstack;
int arandstack;

int calctype;
int TestScript = 0;

unsigned long seed[256];

#include "main.h"
#include "clsRead.h"
#include "clsCharSource.h"
#include "clsFeatSource.h"
#include "clsEquipSource.h"
#include "clsSkillSource.h"
#include "clsRaceSource.h"
#include "clsSpellSource.h"
#include "clsPowerSource.h"
#include "clsEffectSource.h"
#include "clsMonsterSource.h"
#include "clsProfileSource.h"
#include "clsSource.h"

#include "script.h"

#include "CharMain.h"
#include "Equipment.h"
#include "Feats.h"
#include "Skills.h"
#include "Spells.h"
#include "Powers.h"
#include "Monster.h"
#include "clsChar.h"
#include "mixed.h"

#include "ListData.h"
