int CountFeats(clsChar* TargetStruct, int FeatNumber, int featsyet)
{
	int i, temp;
	temp = 0;
	for (i = 0;i < featsyet;i++)
	{
		if (TargetStruct->Feats[i] == FeatNumber)
		{
			temp++;
		}
	}
	return(temp);
}

bool FeatPresent(clsChar* TargetStruct, int FeatNumber, int featsyet, int FeatDep)
{
	int i;
	
	for (i = 0;i < featsyet;i++)
	{
		if (TargetStruct->Feats[i] == FeatNumber &&
			(FeatDep == -2 || TargetStruct->FeatDependancy[i] == FeatDep || TargetStruct->FeatDependancy[i] == -1))
		{
			return(true);
		}
	}
	return(false);
}

bool CheckFinessPossible(clsChar* TargetStruct)
{
	int i;
	for (i = 0;i < TargetStruct->EquipCount;i++)
	{
		if (strcmp(TargetStruct->Equipment[i].Name, "Rapier") == 0 || strcmp(TargetStruct->Equipment[i].Name, "Krummsbel") == 0)
		{
			return(true);
		}
	}
	return(false);
}

bool CheckReq(clsChar* TargetStruct, int FeatNumber, int featsyet, char* ReqStr, int curlevel)
{
	char* ReqPos = ReqStr;
	char* TempPos;
	int ReqID, ReqIVal;
	char ReqTVal[1024];
	int i, len, num;
	bool retval;

	while (*ReqPos)
	{
		ReqID = TwoCharToInt(ReqPos);
		ReqPos += 3;

		if (ReqID == TwoCharToInt("PR"))
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber(ReqPos), featsyet))
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("PG"))
		{
			if (CountFeats(TargetStruct, GetFeatNumber(ReqPos), featsyet) <= CountFeats(TargetStruct, FeatNumber, featsyet))
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("HS"))
		{
			sscanf("ReqPos", "%d", &ReqIVal);
			if (TargetStruct->HighestSpell < ReqIVal)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("KR"))
		{
			sscanf("ReqPos", "%d", &ReqIVal);
			if (!IsClass(TargetStruct, GetCharNumber("Barbar")) || TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barbar"))] / 4 + 1 < ReqIVal)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("GA"))
		{
			sscanf("ReqPos", "%d", &ReqIVal);
			if (TargetStruct->GA < ReqIVal)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("CL"))
		{

			retval = false;
			num = substr_count(asc("|"), ReqPos) + 1;
			len = strlen(ReqPos);

			TempPos = ReqPos;
			str_replace(asc("|"), 0, ReqPos);
			for (i = 0;i < num;i++)
			{
				sscanf(TempPos, "%s %d", ReqTVal, &ReqIVal);
				if (IsClass(TargetStruct, GetCharNumber(ReqTVal)) && TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber(ReqTVal))] >= ReqIVal)
				{
					retval = true;;
				}
				TempPos += strlen(TempPos) + 1;
			}
			str_replace(0, asc("|"), ReqPos, len);
			if (retval == false)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("ST"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[0] < ReqIVal)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("GE"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[1] < ReqIVal)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("KO"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[2] < ReqIVal)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("IN"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[3] < ReqIVal)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("WE"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[4] < ReqIVal)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("CH"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (TargetStruct->Attributes[5] < ReqIVal)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("RA"))
		{
			retval = false;
			num = substr_count(asc("|"), ReqPos) + 1;
			len = strlen(ReqPos);

			TempPos = ReqPos;
			str_replace(asc("|"), 0, ReqPos);
			for (i = 0;i < num;i++)
			{
				if (TargetStruct->Race == GetRaceNumber(TempPos))
				{
					retval = true;
				}
				TempPos += strlen(TempPos) + 1;
			}
			str_replace(0, asc("|"), ReqPos, len);
			if (retval == false)
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("NC"))
		{
			if (IsClass(TargetStruct, GetCharNumber(ReqPos)))
			{
				return(false);
			}
		}
		else if (ReqID == TwoCharToInt("LV"))
		{
			sscanf(ReqPos, "%d", &ReqIVal);
			if (curlevel < ReqIVal)
			{
				return(false);
			}
		}
		else
		{
			printf("Unknown Feat Rule: %s\n", ReqPos - 3);
			quitprog();
		}

		ReqPos += strlen(ReqPos) + 1;
	}

	return(true);
}

bool FeatPossible(clsChar* TargetStruct, int FeatNumber, int featsyet)
{
	int i;
	clsChar TestChar;
	ClearChar(&TestChar);
	TestChar.FeatCount = 1;
	TestChar.Feats[0] = FeatNumber;
	SetFeatSkills(&TestChar);

	char* ReqPos;

	ReqPos = Source.FeatSource[FeatNumber].ReqStr;

	if (!CheckReq(TargetStruct, FeatNumber, featsyet, ReqPos))
	{
		return(false);
	}

	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		if (TestChar.SkillRequired[i] > TargetStruct->Level + 3)
		{
			return(false);
		}
	}

	if (GetFeatNumber("Waffenfinesse") == FeatNumber)
	{
		return((TargetStruct->Attributes[1] > TargetStruct->Attributes[0] ? true : false)
			&& (CheckFinessPossible(TargetStruct)));
	}

	if (GetFeatNumber("FamiliarSpell") == FeatNumber)
	{
		return ((TargetStruct->Attributes[3] >= 25 ? true : false) || (TargetStruct->Attributes[4] >= 25 ? true : false));
	}

	if (GetFeatNumber("ImprovedAlignmentBaseCasting") == FeatNumber)
	{
		return ((TargetStruct->HighestSpell >= 9 ? true : false)
		&& (
			TargetStruct->Domains[0] == GetDomainNumber("Gutes")
			|| TargetStruct->Domains[1] == GetDomainNumber("Gutes")
			|| TargetStruct->Domains[0] == GetDomainNumber("Bses")
			|| TargetStruct->Domains[1] == GetDomainNumber("Bses")
			|| TargetStruct->Domains[0] == GetDomainNumber("Chaos")
			|| TargetStruct->Domains[1] == GetDomainNumber("Chaos")
			|| TargetStruct->Domains[0] == GetDomainNumber("Ordnung")
			|| TargetStruct->Domains[1] == GetDomainNumber("Ordnung")
		));
	}

	if (GetFeatNumber("ImprovedArrowOfDeath") == FeatNumber)
	{
		return ((TargetStruct->Attributes[1] >= 19 ? true : false) || (TargetStruct->Attributes[4] >= 19 ? true : false));
	}

	if (GetFeatNumber("ImprovedDarkvision") == FeatNumber)
	{
		return ((TargetStruct->Race == GetRaceNumber("Zwerg") || TargetStruct->Race == GetRaceNumber("Halbork") ? true : false));
	}

	if (GetFeatNumber("ImprovedLowLightVision") == FeatNumber)
	{
		return ((TargetStruct->Race == GetRaceNumber("Elf") || TargetStruct->Race == GetRaceNumber("Halbelf") || TargetStruct->Race == GetRaceNumber("Gnom") ? true : false));
	}

	if (GetFeatNumber("ImprovedSpellCasting") == FeatNumber)
	{
		return (
			(IsClass(TargetStruct, GetCharNumber("Barde")) && (TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barde"))] >= 16 ? true : false))
			|| (TargetStruct->HighestSpell >= 9 ? true : false)
			);
	}

	if (GetFeatNumber("InstantReload") == FeatNumber)
	{
		for (i = 0;i < TargetStruct->EquipCount;i++)
		{
			if (strstr(TargetStruct->Equipment[i].Name, "rmbrust") != 0)
			{
				return(true);
			}
		}
		return(false);
	}
	
	
	if (GetFeatNumber("SpellKnowledge") == FeatNumber)
	{
		return (
			(IsClass(TargetStruct, GetCharNumber("Barde")) && (TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("Barde"))] >= 16 ? true : false))
			|| (TargetStruct->HighestSpell >= 9 ? true : false)
			);
	}
	
	return(true);
}

void DoFeatDep(clsChar* TargetStruct, int FeatNumber)
{
	int i, j, k, l;
	int TempProb[4096];

	char* ReqPos;
	bool CopyFeatDep = false;
	int CopyDepSrc;

	ZeroMemory(TempProb, 4096 * sizeof(int));
	TargetStruct->FeatDependancy[FeatNumber] = -2;
	if (Source.FeatSource[TargetStruct->Feats[FeatNumber]].DepType)
	{
		ReqPos = Source.FeatSource[TargetStruct->Feats[FeatNumber]].ReqStr;
		while (*ReqPos)
		{
			if (TwoCharToInt(ReqPos) == TwoCharToInt("PG"))
			{
				CopyFeatDep = true;
				CopyDepSrc = GetFeatNumber(ReqPos + 3);
				break;
			}
			ReqPos += strlen(ReqPos) + 1;
		}

		if (CopyFeatDep)
		{
			for (i = 0;i < FeatNumber;i++)
			{
				if (TargetStruct->Feats[i] == CopyDepSrc
					&& !FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, TargetStruct->FeatDependancy[i]))
				{
					TargetStruct->FeatDependancy[FeatNumber] = TargetStruct->FeatDependancy[i];
					return;
				}
			}
		}
		else
		{
			if (Source.FeatSource[TargetStruct->Feats[FeatNumber]].DepType == depweapon)
			{
				for (i = 0;i < TargetStruct->EquipCount;i++)
				{
					if (TargetStruct->Equipment[i].EquipType == EquipWeapon && !(FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, GetEquipNumber(TargetStruct->Equipment[i].Name))))
					{
						TargetStruct->FeatDependancy[FeatNumber] = GetEquipNumber(TargetStruct->Equipment[i].Name);
						return;
					}
				}
				for (i = 0;i < Source.EquipSourceCount;i++)
				{
					if (Source.EquipSource[i].EquipType == EquipWeapon && !(FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, GetEquipNumber(Source.EquipSource[i].Name))))
					{
						TempProb[i] = 1;
					}
				}
				TargetStruct->FeatDependancy[FeatNumber] = AdvancedRand(Source.EquipSourceCount, TempProb, sizeof(int), &Source.EquipSource[0].Name[0], (int) ((char*) &Source.EquipSource[1].Name[0] - (char*) &Source.EquipSource[0].Name[0]), "Waffe fr Talent whlen!\n");
			}

			if (Source.FeatSource[TargetStruct->Feats[FeatNumber]].DepType == depspell)
			{
				for (i = 0;i < Source.SchoolSourceCount - 1;i++)
				{
					TempProb[i] = 0;
					if (!FeatPresent(TargetStruct, TargetStruct->Feats[FeatNumber], FeatNumber, i))
					{
						for (l = 0;l < TargetStruct->ClassCount;l++)
						{
							for (j = 0;j <= 9;j++)
							{
								for (k = 0;k < TargetStruct->SpellListCount[l][j];k++)
								{
									if (i == Source.SpellSource[TargetStruct->SpellList[l][j][k]].School)
									{
										TempProb[i] ++;
									}
								}
							}
						}
					}
				}
				if (TargetStruct->Profiled)
				{
					SecureMultiply(&TempProb[Profiles[TargetStruct->Profile].PreferedSchool], TargetStruct->ProfileStrength);
				}
				adverror = 0;
				TargetStruct->FeatDependancy[FeatNumber] = AdvancedRand(Source.SchoolSourceCount - 1, TempProb, sizeof(int), &Source.SchoolSource[0][0], (int) ((char*) &Source.SchoolSource[1][0] - (char*) &Source.SchoolSource[0][0]), "Schule fr Zauberfokus whlen!\n");
				if (TargetStruct->FeatDependancy[FeatNumber] == -1)
				{
					TargetStruct->Feats[FeatNumber] = GetFeatNumber("Abhrtung");
					TargetStruct->FeatDependancy[FeatNumber] = -2;
				}
			}
		}
	}
}

void AddFeat(clsChar* TargetStruct, char* FeatName, int* featsyet, int Dep)
{
	int i;
	for (i = 0;i < *featsyet;i++)
	{
		if ((TargetStruct->Feats[i] == GetFeatNumber(FeatName))
			&& (TargetStruct->FeatDependancy[i] == Dep || TargetStruct->FeatDependancy[i] == -1))
		{
			return;
		}
		if ((TargetStruct->Feats[i] == GetFeatNumber(FeatName))
			&& (Dep == -1))
		{
			TargetStruct->FeatDependancy[i] = -1;
		}
	}
	TargetStruct->Feats[*featsyet] = GetFeatNumber(FeatName);
	TargetStruct->FeatDependancy[*featsyet] = Dep;
	(*featsyet)++;
	TargetStruct->FeatCount++;
}

int CheckFeatReq(clsChar* TargetStruct, int num)
{
	int i;
	char* CheckPos;

	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		CheckPos = Source.CharSource[TargetStruct->Classes[i]].FeatStr;
		while (*CheckPos)
		{
			if (!FeatPresent(TargetStruct, GetFeatNumber(CheckPos), num))
			{
				TargetStruct->Feats[num] = GetFeatNumber(CheckPos);
				DoFeatDep(TargetStruct, num);
				return(1);
			}
			CheckPos += strlen(CheckPos) + 1;
		}
	}
	return(0);
}

void DoFeats(clsChar* TargetStruct, int* ProbabilityMod, int Class, bool ClassFeat, int* featsyet, int Epic = 0)
{
	int i, j, k, l;
	int Probability[1024];
	int ProbSave[1024];
	int ProbDone[1024];
	int temp, temp2; 
	bool featok;
	int FeatTypeMatch;
	char* FeatCheckPos;
	int FeatCheckTemp;

	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		if (ClassFeat)
		{
			Probability[i] = Source.FeatSource[i].Probability[Class] * TargetStruct->Level;
		}
		else
		{
			Probability[i] = 0;
			for (j = 0;j < TargetStruct->ClassCount;j++)
			{
				Probability[i] += Source.FeatSource[i].Probability[TargetStruct->Classes[j]] * TargetStruct->Levels[j];
			}
		}
		Probability[i] += ProbabilityMod[i] * TargetStruct->Level;
		ProbDone[i] = 0;
		if ((Source.FeatSource[i].Epic > Epic))
		{
			Probability[i] = 0;
		}
		if ((Source.FeatSource[i].Epic < Epic))
		{
			Probability[i] /= 10;
		}
	}

	for (i = *featsyet;i < TargetStruct->FeatCount;i++)
	{
		if (CheckFeatReq(TargetStruct, i))
		{
			goto FeatNextA;
		}

		for (j = 0;j < Source.FeatSourceCount;j++)
		{
			if (FeatPresent(TargetStruct, j, i) == true)
			{
				if (Source.FeatSource[j].MultipleTimes == 0)
				{
					Probability[j] = 0;
				}
				else if (Source.FeatSource[j].MultipleTimes == 1 && ProbDone[j] == 0)
				{
					sprintf(tempout, "Enter 1 to make Feat %s possible again\n", Source.FeatSource[j].Name);
					if (random(1, 8, tempout) > 1)
					{
						Probability[j] = 0;
					}
					ProbDone[j] = 1;
				}
			}
			if (ClassFeat && *Source.CharSource[Class].BonusFeatType)
			{
				FeatTypeMatch = 0;
				FeatCheckPos = Source.CharSource[Class].BonusFeatType;
				while (*FeatCheckPos)
				{
					sscanf(FeatCheckPos, "%d", &FeatCheckTemp);
					if (Source.FeatSource[j].FeatType == FeatCheckTemp)
					{
						FeatTypeMatch = 1;
						break;
					}
					FeatCheckPos += strlen(FeatCheckPos) + 1;
				}
				if (FeatTypeMatch == 0)
				{
					Probability[j] = 0;
				}
			}
			else
			{
				if (TargetStruct->WeaponArmorShieldFeats == 1)
				{
					for (k = 0;k < TargetStruct->EquipCount;k++)
					{
						if (TargetStruct->Equipment[k].EquipType == EquipWeapon || TargetStruct->Equipment[k].EquipType == EquipArmor || TargetStruct->Equipment[k].EquipType == EquipShield)
						{
							temp2 = GetFeatNumber(GetTypeName(TargetStruct->Equipment[k].EquipType, TargetStruct->Equipment[k].Type));

							if (temp2 == GetFeatNumber("SchwereRstung") && !FeatPresent(TargetStruct, GetFeatNumber("MittelschwereRstung"), *featsyet))
							{
								temp2 = GetFeatNumber("MittelschwereRstung");
							}
	
							if (temp2 == GetFeatNumber("MittelschwereRstung") && !FeatPresent(TargetStruct, GetFeatNumber("LeichteRstung"), *featsyet))
							{
								temp2 = GetFeatNumber("LeichteRstung");
							}
				
							featok = false;
							for (l = 0;l < TargetStruct->FeatCount;l++)
							{
								if (TargetStruct->Feats[l] == temp2 && (TargetStruct->FeatDependancy[l] == GetEquipNumber(TargetStruct->Equipment[k].Name) || TargetStruct->FeatDependancy[l] == -1))
								{
									featok = true;
								}
							}
			
							if (!featok)
							{
								TargetStruct->Feats[i] = temp2;
								TargetStruct->FeatDependancy[i] = GetEquipNumber(TargetStruct->Equipment[k].Name);
								if (temp2 == GetFeatNumber("EinfacheWaffen")) {TargetStruct->FeatDependancy[i] = -1;}
								goto FeatNext;
							}
						}
					}
				}
			}

			if (Source.FeatSource[j].AttackDep)
			{
				if (TargetStruct->AttackType[0] != AttackTwoWeapons && TargetStruct->AttackType[1] != AttackTwoWeapons)
				{
					if (Source.FeatSource[j].AttackDep == 2)
					{
						Probability[j] = 0;
					}
				}
				if ((TargetStruct->AttackType[0] == AttackBow || TargetStruct->AttackType[0] == AttackNone) && TargetStruct->AttackType[1] == AttackNone)
				{
					if (Source.FeatSource[j].AttackDep == 1)
					{
						Probability[j] = 0;
					}
				}
				if (TargetStruct->AttackType[0] != AttackBow && TargetStruct->AttackType[1] != AttackBow)
				{
					if (Source.FeatSource[j].AttackDep == 4)
					{
						Probability[j] = 0;
					}
				}
			}
		}
		temp = 1;

		if (TargetStruct->Profiled)
		{
			for (l = 0;l < Profiles[TargetStruct->Profile].FeatCount;l++)
			{
				if ((!FeatPresent(TargetStruct, Profiles[TargetStruct->Profile].Feats[l].Feat, i)) &&
					FeatPossible(TargetStruct, Profiles[TargetStruct->Profile].Feats[l].Feat, i) &&
					Probability[Profiles[TargetStruct->Profile].Feats[l].Feat] != 0)
				{
					SecureMultiply(&Probability[Profiles[TargetStruct->Profile].Feats[l].Feat], TargetStruct->ProfileStrength);
					break;
				}
			}
		}

		CopyMemory(ProbSave, Probability, Source.FeatSourceCount * sizeof(int));

		do
		{
			if (temp < 1000)
			{
				sprintf(tempout, "Talent %d / %d\n", i, TargetStruct->FeatCount);
				if (ClassFeat)
				{
					sprintf(tempstring, "Bonustalent: %s\n", Source.CharSource[Class].Name);
					strcat(tempout, tempstring);
				}
					
				strcat(tempout, "Talent whlen!\n");
				adverror = 0;
				TargetStruct->Feats[i] = AdvancedRand(Source.FeatSourceCount, &Probability[0], sizeof(int),
					&Source.FeatSource[0].Name[0], (int) ((char*) &Source.FeatSource[1].Name[0] - (char*) &Source.FeatSource[0].Name[0]), tempout);
				if (TargetStruct->Feats[i] == -1)
				{
					goto NoAppropriate;
				}
			}
			else
			{
NoAppropriate:
				if (DebugOutput) {printf("No apropriate Feat found %d\n", i);}
				tempout[0] = 0;
				for (l = 0;l < Source.FeatSourceCount;l++)
				{
					sprintf(tempstring, "%d: %s\n", l, Source.FeatSource[l].Name);
					strcat(tempout, tempstring);
				}
				strcat(tempout, "Select a Feat!\n");
				TargetStruct->Feats[i] = random(0, Source.FeatSourceCount - 1, tempout);
			}
			if (temp > 1)
			{
				Probability[TargetStruct->Feats[i]] = 0;
			}
			temp++;
		}
		while (!FeatPossible(TargetStruct, TargetStruct->Feats[i], i));

		CopyMemory(Probability, ProbSave, Source.FeatSourceCount * sizeof(int));

FeatNextA:;
		DoFeatDep(TargetStruct, i);
FeatNext:;
		ProbDone[TargetStruct->Feats[i]] = 0;
	}
	*featsyet = TargetStruct->FeatCount;
}

void DoClassRaceFeats(clsChar* TargetStruct, int* featsyetA)
{
	int featsyet;

	featsyet = *featsyetA;
	sAddfeatsyet = &featsyet;

	int i;

	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		classlevel = TargetStruct->Levels[i];
		RunScript(TargetStruct, NULL, TargetStruct->CharText, Source.CharSource[TargetStruct->Classes[i]].ClassFeats);
	}
	classlevel = 0;

	sAddfeatsyet = 0;
	*featsyetA = featsyet;
}

int CalcBonusFeat(char* BonusStr, int CharLevel)
{
	char* BonusPos = BonusStr;
	int CurFeats = 0;
	int Increment, Division;
	while (*BonusPos)
	{
		if (strstr(BonusPos, " "))
		{
			sscanf(BonusPos, "%d %d", &Increment, &Division);
			CurFeats += (CharLevel + Increment) / Division;
		}
		else
		{
			sscanf(BonusPos, "%d", &Increment);
			if (CharLevel > Increment)
			{
				CurFeats++;
			}
		}
		BonusPos += strlen(BonusPos) + 1;
	}
	return(CurFeats);
}

void CalculateFeats(clsChar* TargetStruct)
{
	int i, featsyet = 0;
	int *ProbMod;
	ProbMod = new int[Source.FeatSourceCount];
	int AddFeats;

	char WeaponTemp[1024];
	if (ProbMod == 0)
	{
		printf("Memmory Allocation Error...\n");
		quitprog();
	}

	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		ProbMod[i] = 0;
	}

	DoClassRaceFeats(TargetStruct, &featsyet);

	if (TargetStruct->Domains[0] == GetDomainNumber("Krieg") || TargetStruct->Domains[1] == GetDomainNumber("Krieg"))
	{
		if (TargetStruct->AttackType != AttackNone && TargetStruct->EquipCount)
		{
			i = GetEquipNumber(TargetStruct->Equipment[0].Name);
			AddFeat(TargetStruct, "Waffenfokus",  &featsyet, i);
			if (TargetStruct->Equipment[0].Type == 0) {strcpy(WeaponTemp, "EinfacheWaffen");i = -1;}
			if (TargetStruct->Equipment[0].Type == 1) {strcpy(WeaponTemp, "KriegsWaffen");}
			if (TargetStruct->Equipment[0].Type == 2) {strcpy(WeaponTemp, "ExotischeWaffen");}
			AddFeat(TargetStruct, WeaponTemp, &featsyet, i);
		}
	}

	TargetStruct->FeatCount += min(TargetStruct->Level, 20) / 3 + 1;
	if (TargetStruct->Race == GetRaceNumber("Mensch") && DummyChar == 0) {TargetStruct->FeatCount++;}

	while (TargetStruct->SpecialAbbilities > 0 && random(1, 3, "1 = Use Special Ability as Feat") == 1)
	{
		TargetStruct->SpecialAbbilities--;
		TargetStruct->FeatCount++;;
	}

	DoFeats(TargetStruct, ProbMod, 0, 0, &featsyet);
	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		AddFeats = CalcBonusFeat(Source.CharSource[TargetStruct->Classes[i]].BonusFeats, TargetStruct->LevelsClassic[i]);
		if (AddFeats)
		{
			TargetStruct->FeatCount += AddFeats;
			DoFeats(TargetStruct, ProbMod, TargetStruct->Classes[i], 1, &featsyet);
		}
	}

	TargetStruct->FeatCount += max(0, TargetStruct->Level - 18) / 3;
	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		TargetStruct->FeatCount += (TargetStruct->Levels[i] - TargetStruct->LevelsClassic[i]) / Source.CharSource[TargetStruct->Classes[i]].EpicFeats;
	}
	DoFeats(TargetStruct, ProbMod, 0, 0, &featsyet, 1);

	delete[] ProbMod;
	if (IsClass(TargetStruct, GetCharNumber("PsychicW")) && TargetStruct->Levels[GetClassNum(TargetStruct, GetCharNumber("PsychicW"))] >= 6)
	{
		for (i = 0;i < TargetStruct->FeatCount;i++)
		{
			if (TargetStruct->Feats[i] == GetFeatNumber("Waffenfokus"))
			{
				TargetStruct->Feats[TargetStruct->FeatCount] = GetFeatNumber("Waffenspezialisierung");
				TargetStruct->FeatDependancy[TargetStruct->FeatCount] = TargetStruct->FeatDependancy[i];
				TargetStruct->FeatDone[TargetStruct->FeatCount] = 0;
				TargetStruct->FeatCount++;
			}
		}
	}
}

void SetMin(int* val, int minval)
{
	*val = max(*val, minval);
}

void SetReqSkills(clsChar* TargetStruct, char* SkillReqStr)
{
	char SkillName[256];
	int SkillLvl;
	char* SkillPos = SkillReqStr;
	while (*SkillPos)
	{
		sscanf(SkillPos, "%s %d", SkillName, &SkillLvl);
		SetMin(&TargetStruct->SkillRequired[GetSkillNumber(SkillName)], SkillLvl);
		SkillPos += strlen(SkillPos) + 1;
	}
}

void SetFeatSkills(clsChar* TargetStruct)
{
	int i;
	char* SkillPos;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		SkillPos = Source.FeatSource[TargetStruct->Feats[i]].SkillStr;
		SetReqSkills(TargetStruct, SkillPos);
	}
}

void SetFeatSkillsA(clsChar* TargetStruct)
{
	int i;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		if (Source.FeatSource[TargetStruct->Feats[i]].DepType == depskill)
		{
			sprintf(tempout, "Fertigkeit fr Fertigkeitsbezogenes Talent %s whlen! whlen!\n", Source.FeatSource[TargetStruct->Feats[i]].Name);
			if (TargetStruct->SkillCount == 0)
			{
				TargetStruct->FeatDependancy[i] = random(0, Source.SkillSourceCount - 1, tempout);
			}
			else
			{
				TargetStruct->FeatDependancy[i] = TargetStruct->Skills[random(0, TargetStruct->SkillCount - 1, tempout)];
			}
		}
	}
}

void DoFeatEffects(clsChar* TargetStruct)
{
	int i, j, k;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		if (TargetStruct->Feats[i] == GetFeatNumber("Beidhndigkeit"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				TargetStruct->Equipment[j].AttackBonusA -= 4;
				if (TargetStruct->Equipment[j].TwoWeaponSecond == 1)
				{
					TargetStruct->Equipment[j].AttackBonus += 4;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("KampfMitZweiWaffen"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (TargetStruct->Equipment[j].TwoWeapon == 1)
				{
					TargetStruct->Equipment[j].AttackBonus += 2;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("VerbesserterKritischerTreffer"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].CriticalMultiplier2++;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Fertigkeitsfokus"))
		{
			BoostSkillA(TargetStruct, TargetStruct->FeatDependancy[i], 2);
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Waffenfokus"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].AttackBonus++;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Waffenspezialisierung"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].Damage3 += 2;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Waffenfinesse"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].AttackBonus -= TargetStruct->Mods[0];
					TargetStruct->Equipment[j].AttackBonus += TargetStruct->Mods[1];
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Kampfreflexe"))
		{
			TargetStruct->AttacksOpportunity += GreaterZero(TargetStruct->Mods[1]);
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ZustzlichesVertreiben"))	{}
		else if (TargetStruct->Feats[i] == GetFeatNumber("PsionicBody"))
		{
			if (IsClass(TargetStruct, GetCharNumber("Psion")))
			{
				if (TargetStruct->Mods[TargetStruct->MainDisciple] > TargetStruct->Mods[2])
				{
					TargetStruct->LifeBonus += TargetStruct->Mods[TargetStruct->MainDisciple];
					TargetStruct->LifeBonus -= TargetStruct->Mods[2];
				}
			}
			for (j = 0;j < TargetStruct->FeatCount;j++)
			{
				if (TargetStruct->Feats[j] == GetFeatNumber("DelayPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("EnlargePower")
					|| TargetStruct->Feats[j] == GetFeatNumber("ExtendPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("HeightenPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("HidePower")
					|| TargetStruct->Feats[j] == GetFeatNumber("MasterDorje")
					|| TargetStruct->Feats[j] == GetFeatNumber("MaximizePower")
					|| TargetStruct->Feats[j] == GetFeatNumber("QuickenPower")
					|| TargetStruct->Feats[j] == GetFeatNumber("TwinPower"))
				{
					TargetStruct->LifeBonus++;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("BulwarkOfDefense")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("DamageReduction"))
		{
			strcat(TargetStruct->CharText, "Schadensreduktion 3/-\n");
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EnergyResistance"))
		{
			sprintf(tempout, "+10 Wiederstand gegen %s\n", GetElement(random(0, 2, "Element fr Wiederstand?")));
			strcat(TargetStruct->CharText, tempout);
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicProwess"))
		{
			TargetStruct->GAMeleeRest++;
			TargetStruct->GAShotRest++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicSkillFocus"))
		{
			int skillfound = 0;
			TargetStruct->SkillPoints += 10;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->SkillLevels[j] += 10;
					skillfound = 1;
				}
			}
			if (skillfound == 0)
			{
				TargetStruct->Skills[TargetStruct->SkillCount] = TargetStruct->FeatDependancy[i];
				TargetStruct->SkillLevels[TargetStruct->SkillCount] = 10;
				TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
				TargetStruct->SkillCount++;
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicSpellcasting"))
		{
			k = 0;
			for (j = 0;j < TargetStruct->SkillCount;j++)
			{
				if (TargetStruct->Skills[j] == GetSkillNumber("WissenArkanes"))
				{
					k = TargetStruct->SkillLevels[j] / 10;
					break;
				}
			}
			sprintf(tempout, "Kann pro Tag %d Epic Spells\n", k);
			strcat(TargetStruct->CharText, tempout);
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicWeaponFocus"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].AttackBonus += 2;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EpicWeaponSpezialisation"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (GetEquipNumber(TargetStruct->Equipment[j].Name) == TargetStruct->FeatDependancy[i])
				{
					TargetStruct->Equipment[j].Damage3 += 4;
				}
			}
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("FleetOfFoot"))
		{
			TargetStruct->Range += 9;
		}

		else if (TargetStruct->Feats[i] == GetFeatNumber("GreatSmiting")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImprovedArrowOfDeath")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImprovedAuraOfCourage")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImprovedDeathAttack")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("MightyRage")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ImprovedPsychristal"))
		{
			TargetStruct->CrystalCount++;
		}
		else if (TargetStruct->Feats[i] == GetFeatNumber("LeichteRstung")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("MittelschwereRstung")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("SchwereRstung")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Schilde")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("EinfacheWaffen")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("KriegsWaffen")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("ExotischeWaffen")) {}
		else if (TargetStruct->Feats[i] == GetFeatNumber("Kernschuss"))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				if (TargetStruct->Equipment[j].Type == AttackBow)
				{
					TargetStruct->Equipment[j].AttackBonus++;
					TargetStruct->Equipment[j].Damage3++;
				}
			}
		}
		else
		{
			TargetStruct->FeatDone[i] = 1;
		}

		if (Source.FeatSource[TargetStruct->Feats[i]].Script[5] != asc(";"))
		{
			TargetStruct->FeatDone[i] = 0;
			RunScript(TargetStruct, NULL, TargetStruct->CharText, Source.FeatSource[TargetStruct->Feats[i]].Script);
		}
	}
	
	j = -1;
	k = 0;
	for (i = 0;i < TargetStruct->EquipCount;i++)
	{
		if (!(
			FeatPresent(TargetStruct, GetFeatNumber("EinfacheWaffen"), TargetStruct->FeatCount, GetEquipNumber(TargetStruct->Equipment[i].Name))
			|| FeatPresent(TargetStruct, GetFeatNumber("KriegsWaffen"), TargetStruct->FeatCount, GetEquipNumber(TargetStruct->Equipment[i].Name))
			|| FeatPresent(TargetStruct, GetFeatNumber("ExotischeWaffen"), TargetStruct->FeatCount, GetEquipNumber(TargetStruct->Equipment[i].Name))
			))
		{
			TargetStruct->Equipment[i].AttackBonus -= 4;
		}
		if (TargetStruct->Equipment[i].EquipType == EquipArmor && strcmp(TargetStruct->Equipment[i].Name, "Magierrobe") != 0)
		{
			j = max(j, TargetStruct->Equipment[i].Type);
		}
		if (TargetStruct->Equipment[i].EquipType == EquipShield)
		{
			k = 1;
		}
	}
	if (j >= 0)
	{
		if (!(FeatPresent(TargetStruct, GetFeatNumber(GetTypeName(EquipArmor, j)), TargetStruct->FeatCount)))
		{
			for (j = 0;j < TargetStruct->EquipCount;j++)
			{
				TargetStruct->Equipment[j].AttackBonus -= 4;
			}
			TargetStruct->ArmorMalus += 4;
		}
	}
	if (k == 1 && (!(FeatPresent(TargetStruct, GetFeatNumber("Schilde"), TargetStruct->FeatCount))))
	{
		for (j = 0;j < TargetStruct->EquipCount;j++)
		{
			TargetStruct->Equipment[j].AttackBonus -= 4;
		}
		TargetStruct->ArmorMalus += 4;
	}
}

void StripFeats(clsChar* TargetStruct)
{
	int i;
	int j;

	for (i = 0;i < TargetStruct->FeatCount;i++)
	{
		for (j = 0;j < TargetStruct->FeatCount;j++)
		{
			if (i != j)
			{
				if (TargetStruct->Feats[i] == TargetStruct->Feats[j])
				{
					if (TargetStruct->FeatDependancy[i] == TargetStruct->FeatDependancy[j] ||
						TargetStruct->FeatDependancy[i] == -1)
					{
						TargetStruct->Feats[j] = TargetStruct->Feats[TargetStruct->FeatCount - 1];
						TargetStruct->FeatDependancy[j] = TargetStruct->FeatDependancy[TargetStruct->FeatCount - 1];
						TargetStruct->FeatDone[j] = TargetStruct->FeatDone[TargetStruct->FeatCount - 1];
						TargetStruct->FeatCount--;
					}
				}
			}
			if (i >= TargetStruct->FeatCount)
			{
				break;
			}
		}
	}
}