namespace bnf {

#include "main.h"

int GetPath(char** PathName, char* FileName)
{
	char moduleName[1025];
	int moduleNameLen;
	int i;
	if (!(GetModuleFileName(NULL, moduleName, 1024)))
	{
		return(1);
	}

	moduleNameLen = strlen(moduleName);
	
	for (i = (moduleNameLen - 1);(signed) i >= 0;i--)
	{
		if (moduleName[i] == 92)
		{
			moduleName[i + 1] = 0;
			break;
		}
	}

	if (!(*PathName = (char*) malloc(strlen(moduleName) + 1 + (FileName == NULL ? 0 : strlen(FileName)))))
	{
		printf("Memmory Allocation Error\n");
		return(1);
	}

	strcpy(*PathName, moduleName);
	if (FileName)
	{
		strcat(*PathName, FileName);
	}
	return(0);
}

int GetPrivateProfileStringA(char* lpSectionName, char* lpKeyName, char** lpBuffer)
{
	int CurSize = 0;
	int rVal = 0;
	bool MemOK = false;
	char* PathName;

	*lpBuffer = 0;

	GetPath(&PathName, ConfigFile);
	while (rVal >= CurSize - 3)
	{
		if (*lpBuffer)
		{
			free(*lpBuffer);
			*lpBuffer = 0;
		}
		CurSize += 16;
		if ((*lpBuffer = (char*) malloc(CurSize + 4)) == 0)
		{
			printf("Memory Allocation Error\n");
			return(1);
		}
		rVal = GetPrivateProfileString(lpSectionName, lpKeyName, "", *lpBuffer, CurSize - 1, PathName);
	}
	free(PathName);

	return(0);
}

unsigned long ReadFileToBuffer(char* FileName, char** Buffer)
{
	HANDLE hFile;
	unsigned long FileSize;
	unsigned long i;

	if (DebugOutput)
	{
		printf("Opening file\n");
	}
	hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, 0);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		printf("Could not open file\n");
		return(0);
	}
	
	if (DebugOutput)
	{
		printf("Getting File Size\n");
	}
	FileSize = GetFileSize(hFile, &i);
	if (DebugOutput)
	{
		printf("Allocating Memmory to read File\n");
	}
	*Buffer = (char*) malloc(FileSize);
	if (*Buffer == 0)
	{
		printf("Memmory Allocation Error\n");
		return(0);
	}

	if (DebugOutput)
	{
		printf("Reading File\n");
	}
	ReadFile(hFile, *Buffer, FileSize, &i, NULL);
	if (i != FileSize)
	{
		printf("Error reading File\n");
		return(0);
	}

	if (DebugOutput)
	{
		printf("Closing File\n");
	}
	CloseHandle(hFile);

	return(FileSize);
}

char asc(char* val)
{
	return(val[0]);
}

char* SkipRule(char* pRule)
{
	int CurOrder;

	CurOrder = *((int*) pRule);
	if (CurOrder == gEnd)
	{
		pRule += 4;
	}
	else if (CurOrder == gSep || CurOrder == gOr || CurOrder == gNot)
	{
			pRule += 4;
	}
	else if (CurOrder == gString) {
		pRule += 4;
		pRule += (*((int*) pRule)) + 4;
	}
	else if (CurOrder == gGroup || CurOrder == gRep || CurOrder == gOpt || CurOrder == gLink) 
	{
		pRule += 8;
	}
	else
	{
		printf("Internal Error\n");
	}

	return(pRule);
}

char ucase(char val)
{
	if (!CaseSensitive && (val | 32) >= asc("a") && (val | 32) <= asc("z"))
	{
		return(val | 32);
	}
	else
	{
		return(val);
	}
}

int ProcessFiles(int argc, char** argv, int ProcessFunction(char*))
{
	int i;
	WIN32_FIND_DATA fInfo;
	HANDLE hFileSearch;

	for (i = 0;i < argc;i++)
	{
		printf("Searching File(s): %s\n", argv[i]);

		hFileSearch = FindFirstFile(argv[i], &fInfo);
		if (hFileSearch == INVALID_HANDLE_VALUE)
		{
			printf("Could not find %s\n", argv[i]);
		}
		else
		{
			int j = FILE_ATTRIBUTE_DIRECTORY;
			do
			{
				if ((fInfo.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0)
				{
					printf("Found File: %s\n", fInfo.cFileName);
					if (ProcessFunction(fInfo.cFileName))
					{
						printf("ERROR IN FILE: %s\n", fInfo.cFileName);
						return(1);
					}
					printf("\n");
				}
			} while (FindNextFile(hFileSearch, &fInfo) != false);
		}
		printf("\n");
	}

	printf("All Files Done\n");
	return(0);
}

}