extern char* DoRule(char* CodePos, char* Symbol, int tCompressed, char* tSymbolName = NULL, bool not = false);
extern char* pInitSymbol;

extern char* pTree;
extern int nTreeSize, nTreeSizeMax;
extern char* SourceBuffer;
extern unsigned long SourceFileSize;

bool bnfinitdone = false;

int bnfinit()
{
	if (bnfinitdone)
	{
		return(0);
	}

	if (DebugOutput)
	{
		printf("Reading Config\n");
	}
	if (ReadConfig())
	{
		printf("Error Reading Config File\n");
		getchar();
		return(1);
	}

	if (InitGrammar())
	{
		printf("Error Initializing Grammar\n");
		getchar();
		return(1);
	}

	bnfinitdone = true;

	if (DebugOutput) {printf("\n\n");}
	return(0);
}

int bnfparse(char* Source, char** ppTree)
{
	if (DebugOutput)
	{
		printf("Splitting Script\n");
	}

	SourceBuffer = Source;
	SourceFileSize = strlen(Source);

	if (DoRule(Source, pInitSymbol, 0) != Source + strlen(Source))
	{
		printf("Content does not match Grammar\n");
		return(1);
	}
	if (DebugOutput)
	{
		printf("Script Matches Grammar\n");
	}

	if ((*ppTree = (char*) malloc(nTreeSize)) == 0)
	{
		printf("Memmory Allocaiton Error\n");
		return(1);
	}

	CopyMemory(*ppTree, pTree, nTreeSize);
	nTreeSize = 0;

	return(0);
}

int bnfexit()
{
	if (bnfinitdone)
	{
		if (ExitGrammar())
		{
			printf("Error Unloading Grammar\n");
			getchar();
			return(1);
		}

		free(SymbolNames);
		free(SymbolPointer);

		free(lpSeperatorBytes);
		free(lpComments);
		bnfinitdone = false;
	}

	return(0);
}