void SetMonsterSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i;

	static int name, cr, type, size, epic, hd, hdtype, tp, rwref, rwwil, rwzaeh, attr[6];
	static int ac, hdmin, hdmax, hdinc, hdinc2, init, speed, orgmin, orgmax, mix, treasure;
	static int att[6], num[6], red[6], dmga[6], dmgb[6], dmgc[6], atype[6], altern[2], feats[6], skills[7], skilll[7];
	static int spellcharpos, clericspellpos;
	static int valcount;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		cr = GetValNumber(Vals, "CR", Number);
		type = GetValNumber(Vals, "Type", Number);
		size = GetValNumber(Vals, "Size", Number);
		epic = GetValNumber(Vals, "Epic", Number);
		hd = GetValNumber(Vals, "HD", Number);
		hdtype = GetValNumber(Vals, "HDT", Number);
		tp = GetValNumber(Vals, "TP", Number);
		rwref = GetValNumber(Vals, "Ref", Number);
		rwwil = GetValNumber(Vals, "Wil", Number);
		rwzaeh = GetValNumber(Vals, "Zaeh", Number);
		for (i = 0;i < 6;i++)
		{
			attr[i] = GetValNumber(Vals, GetAttributeName(i), Number);
		}

		ac = GetValNumber(Vals, "AC", Number);
		hdmin = GetValNumber(Vals, "HDMin", Number);
		hdmax = GetValNumber(Vals, "HDMax", Number);
		hdinc = GetValNumber(Vals, "HDInc", Number);
		hdinc2 = GetValNumber(Vals, "HDInc2", Number);
		init = GetValNumber(Vals, "Init", Number);
		speed = GetValNumber(Vals, "Speed", Number);
		orgmin = GetValNumber(Vals, "OrgMin", Number);
		orgmax = GetValNumber(Vals, "OrgMax", Number);
		mix = GetValNumber(Vals, "Mixed", Number);
		treasure = GetValNumber(Vals, "Treasur", Number);

		spellcharpos = GetValNumber(Vals, "SpellChar", Number);
		clericspellpos = GetValNumber(Vals, "ClericSpells", Number);

		for (i = 0;i < 6;i++)
		{
			sprintf(tempout, "Attack%d", i + 1);
			att[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Number%d", i + 1);
			num[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "AttRed%d", i + 1);
			red[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Dmg%dA", i + 1);
			dmga[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Dmg%dB", i + 1);
			dmgb[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Dmg%dC", i + 1);
			dmgc[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Type%d", i + 1);
			atype[i] = GetValNumber(Vals, tempout, Number);
			if (i < 2) 
			{
				sprintf(tempout, "Altern%d", i + 1);
				altern[i] = GetValNumber(Vals, tempout, Number);
			}
			sprintf(tempout, "Feat%d", i + 1);
			feats[i] = GetValNumber(Vals, tempout, Number);
		}
		for (i = 0;i < 7;i++)
		{
			sprintf(tempout, "Skill%d", i + 1);
			skills[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "SkillL%d", i + 1);
			skilll[i] = GetValNumber(Vals, tempout, Number);
		}
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in MonsterSource Database (%d %d)\n", Number, valcount);
		quitprog();
	}

	strcpy(((clsMonster*) TargetStruct)->Name, Vals[name]);

	FILE* fka;
	sprintf(tempout, "MonsterText\\%s", Vals[name]);
	fka = fopen(tempout, "r");
	if (fka == 0) {
		printf("Monster Description not found%s\n", Vals[name]);
		quitprog();
	} else {
		fclose(fka);
	}


	sscanf(Vals[cr], "%d", &(((clsMonster*) TargetStruct)->CR));

	((clsMonster*) TargetStruct)->Type = GetMonsterTypeNumber(Vals[type]);
	((clsMonster*) TargetStruct)->Size = GetSizeNumber(Vals[size]);

	sscanf(Vals[epic], "%d", &(((clsMonster*) TargetStruct)->Epic));
	sscanf(Vals[hd], "%d", &(((clsMonster*) TargetStruct)->HD));
	sscanf(Vals[hdtype], "%d", &(((clsMonster*) TargetStruct)->HDType));
	sscanf(Vals[tp], "%d", &(((clsMonster*) TargetStruct)->TPBonus));
	sscanf(Vals[rwref], "%d", &(((clsMonster*) TargetStruct)->RWRef));
	sscanf(Vals[rwwil], "%d", &(((clsMonster*) TargetStruct)->RWWil));
	sscanf(Vals[rwzaeh], "%d", &(((clsMonster*) TargetStruct)->RWZaeh));
	for (i = 0;i < 6;i++)
	{
		sscanf(Vals[attr[i]], "%d", &(((clsMonster*) TargetStruct)->Attr[i]));
	}
	sscanf(Vals[ac], "%d", &(((clsMonster*) TargetStruct)->AC));
	sscanf(Vals[hdmin], "%d", &(((clsMonster*) TargetStruct)->HDMin));
	sscanf(Vals[hdmax], "%d", &(((clsMonster*) TargetStruct)->HDMax));
	sscanf(Vals[hdinc], "%d", &(((clsMonster*) TargetStruct)->HDInc));
	sscanf(Vals[hdinc2], "%d", &(((clsMonster*) TargetStruct)->HDInc2));
	sscanf(Vals[init], "%d", &(((clsMonster*) TargetStruct)->Init));
	sscanf(Vals[speed], "%d", &(((clsMonster*) TargetStruct)->Speed));
	sscanf(Vals[orgmin], "%d", &(((clsMonster*) TargetStruct)->OrgMin));
	sscanf(Vals[orgmax], "%d", &(((clsMonster*) TargetStruct)->OrgMax));
	sscanf(Vals[mix], "%d", &(((clsMonster*) TargetStruct)->Mixed));
	sscanf(Vals[treasure], "%d", &(((clsMonster*) TargetStruct)->Treasure));

	if ((((clsMonster*) TargetStruct)->SpellChar = (char*) malloc(strlen(Vals[spellcharpos]) + 1)) == 0)
	{
		printf("Memmory Allocation Error\n");
		quitprog();
	}
	strcpy(((clsMonster*) TargetStruct)->SpellChar, Vals[spellcharpos]);
	str_replace(asc(":"), asc(" "), ((clsMonster*) TargetStruct)->SpellChar);
	str_replace(asc(";"), 0, ((clsMonster*) TargetStruct)->SpellChar);

	sscanf(Vals[clericspellpos], "%d", &(((clsMonster*) TargetStruct)->ClericSpells));

	for (i = 0;i < 6;i++)
	{
		if (Vals[atype[i]][0] == 48)
		{
			break;
		}
		sscanf(Vals[att[i]], "%d", &(((clsMonster*) TargetStruct)->AttackBonus[i]));
		sscanf(Vals[num[i]], "%d", &(((clsMonster*) TargetStruct)->AttackNumber[i]));
		sscanf(Vals[red[i]], "%d", &(((clsMonster*) TargetStruct)->AttackRed[i]));
		sscanf(Vals[dmga[i]], "%d", &(((clsMonster*) TargetStruct)->DamageA[i]));
		sscanf(Vals[dmgb[i]], "%d", &(((clsMonster*) TargetStruct)->DamageB[i]));
		sscanf(Vals[dmgc[i]], "%d", &(((clsMonster*) TargetStruct)->DamageC[i]));
		strcpy(&((clsMonster*) TargetStruct)->AttackType[i][0], Vals[atype[i]]);

		if (i < 2) 
		{
			sscanf(Vals[altern[i]], "%d", &(((clsMonster*) TargetStruct)->AlternateAttack[i]));
		}
		else if (strcmp(Vals[atype[i]], "Slap") == 0)
		{
			((clsMonster*) TargetStruct)->AlternateAttack[i] = 3;
		}
		else
		{
			((clsMonster*) TargetStruct)->AlternateAttack[i] = 0;
		}
	}
	((clsMonster*) TargetStruct)->AttackCount = i;
	for (i = 0;i < 6;i++)
	{
		if (Vals[feats[i]][0] == 48)
		{
			break;
		}
		((clsMonster*) TargetStruct)->Feats[i] = GetFeatNumber(Vals[feats[i]], 1);
	}
	((clsMonster*) TargetStruct)->FeatCount = i;
	for (i = 0;i < 7;i++)
	{
		if (Vals[skills[i]][0] == 48)
		{
			break;
		}
		((clsMonster*) TargetStruct)->Skills[i] = GetSkillNumber(Vals[skills[i]], 1);
		sscanf(Vals[skilll[i]], "%d", &(((clsMonster*) TargetStruct)->SkillLevels[i]));
	}
	((clsMonster*) TargetStruct)->SkillCount = i;
}

int GetMonsterNumber(char* MonsterName)
{
	int i;
	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		if (strcmp(MonsterName, Source.MonsterSource[i].Name) == 0)
		{
			return(i);
		}
	}
	printf("Monster not found(%s)\n", MonsterName);
	quitprog();
	return(0);
}

int MonsterSourceInit()
{
	int i;
	FILE* fChar;

	if (DebugOutput) {printf("Opening Monster Templates (%s)\t", MonsterFile);}
	fChar = fopen(MonsterFile, "r");
	if (fChar == 0)
	{
		printf("FAILED\n");
		return(1);
	}
	if (DebugOutput) {printf("OK\nReading Monster Templates\t\t\t");}
	ProcessLine(fChar, &SetMonsterSource, NULL, true);
	Source.MonsterSourceCount = CountSetLines(fChar);
	if (DebugOutput) {printf("%d\n", Source.MonsterSourceCount);}
	Source.MonsterSource = new clsMonster[Source.MonsterSourceCount];
	if (Source.MonsterSource == 0)
	{
		printf("Memmory Allocation Error...\n");
		fclose(fChar);
		return(1);
	}
	if (DebugOutput) {printf("\t( ");}

	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		ProcessLine(fChar, &SetMonsterSource, &Source.MonsterSource[i], false);
		if (DebugOutput) {printf("%s ", Source.MonsterSource[i].Name);}
	}
	if (DebugOutput) {printf(")\n");}
	if (DebugOutput) {printf("\n");}

	fclose(fChar);

	return(0);
}

void MonsterSourceExit()
{
	int i;
	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		free(Source.MonsterSource[i].SpellChar);
	}
	delete[] Source.MonsterSource;
}