void SetPowerSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int name, psion, psiw, attr, valcount;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		psion = GetValNumber(Vals, "Psion", Number);
		psiw = GetValNumber(Vals, "PsychicW", Number);
		attr = GetValNumber(Vals, "Attribute", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in Power Source Database\n");
		quitprog();
	}
	
	strcpy(((clsPower*) TargetStruct)->Name, Vals[name]);
	sscanf(Vals[psion], "%d", &(((clsPower*) TargetStruct)->Psion));
	sscanf(Vals[psiw], "%d", &(((clsPower*) TargetStruct)->PsychicW));
	sscanf(Vals[attr], "%d", &(((clsPower*) TargetStruct)->Attribute));
}

int GetPowerNumber(char* PowerName)
{
	int i;
	for (i = 0;i < Source.PowerSourceCount;i++)
	{
		if (strcmp(PowerName, Source.PowerSource[i].Name) == 0)
		{
			return(i);
		}
	}
	printf("Power not found(%s)\n", PowerName);
	quitprog();
	return(0);
}

int PowerSourceInit()
{
	int i;
	FILE *fChar;

	if (DebugOutput) {printf("Opening Power List (%s)\t\t\t", PowerFile);}
	fChar = fopen(PowerFile, "r");
	if (fChar == 0)
	{
		printf("FAILED\n");
		return(1);
	}
	if (DebugOutput) {printf("OK\nReading Power List\t\t\t\t");}
	ProcessLine(fChar, &SetPowerSource, NULL, true);
	Source.PowerSourceCount = CountSetLines(fChar);
	if (DebugOutput) {printf("%d\n", Source.PowerSourceCount);}
	Source.PowerSource = new clsPower[Source.PowerSourceCount];
	if (Source.PowerSource == 0)
	{
		printf("Memmory Allocation Error...\n");
		fclose(fChar);
		return(1);
	}
	if (DebugOutput) {printf("\t( ");}

	for (i = 0;i < Source.PowerSourceCount;i++)
	{
		ProcessLine(fChar, &SetPowerSource, &Source.PowerSource[i], false);
		if (DebugOutput) {printf("%s ", Source.PowerSource[i].Name);}
	}
	if (DebugOutput) {printf(")\n");}
	if (DebugOutput) {printf("\n");}

	fclose(fChar);

	return(0);
}

void PowerSourceExit()
{
	delete[] Source.RaceSource;
}