unsigned char* lpCodeStart;
char* lpSymbolStart;
int DebugSpare = 0;

clsChar* pCurChar;
clsEquip* pCurEquip;
char* pCurText;

struct ArgStruct
{
	int type;
	int val;
};

ArgStruct Args[2048];
int ArgCount = 0;

int ParseScript(unsigned char* script, int depth = 0, char* pThisSymbol = "");

char strterm[16];
bool strborderinuse[16];
char strborder[16];
int strstack = 0;

void LockString(unsigned char* Str)
{
	int i = 0;

	if (strstack == 16)
	{
		printf("Fatal Error\nString Stack Exceeded\n");
		quitprog();
	}

	while (Str[i] > 1){i++;}
	strterm[strstack] = Str[i];
	Str[i] = 0;
	if (Str[strlen((char*) Str) - 1] == asc("'") || Str[strlen((char*) Str) - 1] == asc("\""))
	{
		strborderinuse[strstack] = true;
		strborder[strstack] = Str[strlen((char*) Str) - 1];
		Str[strlen((char*) Str) - 1] = 0;
	}
	strstack++;
}

void ReleaseString(unsigned char* Str)
{
	strstack--;
	if (strborderinuse[strstack])
	{
		Str[strlen((char*) Str)] = strborder[strstack];
	}
	Str[strlen((char*) Str)] = strterm[strstack];
	strborderinuse[strstack] = false;
}

#include "scriptvar.h"
#include "scriptfuncs.h"
#include "scriptvalset.h"

int EvalExpr(unsigned char* script)
{
	int ArgOld, progress;
	int EvalVal;

	if (DebugOutput) {printf(" Evaluating:");}
	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	if (Args[ArgOld + 1].val == asc("+"))
	{
		EvalVal = Args[ArgOld].val + Args[ArgOld + 2].val;
	}
	else if (Args[ArgOld + 1].val == asc("-"))
	{
		EvalVal = Args[ArgOld].val - Args[ArgOld + 2].val;
	}
	else if (Args[ArgOld + 1].val == asc("*"))
	{
		EvalVal = Args[ArgOld].val * Args[ArgOld + 2].val;
	}
	else if (Args[ArgOld + 1].val == asc("/"))
	{
		EvalVal = Args[ArgOld].val / Args[ArgOld + 2].val;
	}
	else if (Args[ArgOld + 1].val == asc("%"))
	{
		EvalVal = Args[ArgOld].val % Args[ArgOld + 2].val;
	}

	ArgCount = ArgOld;

	Args[ArgCount].type = 0;
	Args[ArgCount].val = EvalVal;
	ArgCount++;

	if (DebugOutput) {printf(" Returned %d:", EvalVal);}

	return(progress);
}

int EvalMaxMin(unsigned char* script, int Max)
{
	int ArgOld, progress;
	int EvalVal;

	if (DebugOutput) {printf(" Max Function:");}

	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	if (Max)
	{
		EvalVal = max(Args[ArgOld].val, Args[ArgOld + 1].val);
	}
	else
	{
		EvalVal = min(Args[ArgOld].val, Args[ArgOld + 1].val);
	}

	ArgCount = ArgOld;
	Args[ArgCount].type = 0;
	Args[ArgCount].val = EvalVal;

	if (DebugOutput) {printf(" Returned %d:", EvalVal);}

	return(progress);
}

void LockCharToInt(int nArg)
{
	int converttemp;

	if (Args[nArg].type == 1)
	{
		LockString((unsigned char*) Args[nArg].val);
		sscanf((char*) Args[nArg].val + 1, "%d", &converttemp);
		ReleaseString((unsigned char*) Args[nArg].val);
		Args[nArg].val = converttemp;
		Args[nArg].type = 0;
	}
}

int condition_all(unsigned char* script)
{
	int progress, ArgOld;
	
	ArgOld = ArgCount;
	progress = ParseScript(script, 1);

	if (ArgCount == ArgOld + 3)
	{
		if (Args[ArgOld + 1].val == asc("&"))
		{
			Args[ArgOld].val = Args[ArgOld].val && Args[ArgOld + 2].val;
		}
		else if (Args[ArgOld + 1].val == asc("|"))
		{
			Args[ArgOld].val = Args[ArgOld].val || Args[ArgOld + 2].val;
		}
		else
		{
			printf("Fatal Scripting Error\n");
			quitprog();
		}
		ArgCount = ArgOld + 1;
	}

	return(progress);
}

int condition(unsigned char* script)
{
	int progress, ArgOld;
	int Result;
	int comparetype;

	bool ConvertToInt = false;

	if (DebugOutput) {printf(" Checking condition:");}

	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	LockString((unsigned char*) Args[ArgOld + 1].val);
	comparetype = TwoCharToInt((char*) Args[ArgOld + 1].val, true);
	ReleaseString((unsigned char*) Args[ArgOld + 1].val);

	if (comparetype != TwoCharToInt("==") && comparetype != TwoCharToInt("!="))
	{
		ConvertToInt = true;
	}
	if (Args[ArgOld].type == 0 || Args[ArgOld + 2].type == 0)
	{
		ConvertToInt = true;
	}

	if (ConvertToInt)
	{
		LockCharToInt(ArgOld);
		LockCharToInt(ArgOld + 2);
	}

	if (comparetype == TwoCharToInt("==") || comparetype == TwoCharToInt("!="))
	{
		if (Args[ArgOld].type == 0)
		{
			Result = (Args[ArgOld].val == Args[ArgOld + 2].val);
		}
		else
		{
			LockString((unsigned char*) Args[ArgOld].val);
			LockString((unsigned char*) Args[ArgOld + 2].val);
			Result = (strcmp((char*) Args[ArgOld].val + 1, (char*) Args[ArgOld + 2].val + 1) == 0);
			ReleaseString((unsigned char*) Args[ArgOld + 2].val);
			ReleaseString((unsigned char*) Args[ArgOld].val);
		}
		if (comparetype == TwoCharToInt("!="))
		{
			Result ^= 1;
		}
	}
	else if (comparetype == TwoCharToInt("<="))
	{
		Result = (Args[ArgOld].val <= Args[ArgOld + 2].val);
	}
	else if (comparetype == TwoCharToInt(">="))
	{
		Result = (Args[ArgOld].val >= Args[ArgOld + 2].val);
	}
	else if (comparetype == asc("<"))
	{
		Result = (Args[ArgOld].val < Args[ArgOld + 2].val);
	}
	else if (comparetype == asc(">"))
	{
		Result = (Args[ArgOld].val > Args[ArgOld + 2].val);
	}
	
	ArgCount = ArgOld;

	Args[ArgCount].type = 0;
	Args[ArgCount].val = Result;
	ArgCount++;
	
	return(progress);
}

int sIfDone[256];
int sIfApplied[256];
int sIfStack = -1;

int sIf(unsigned char* script)
{
	int ArgOld, progress;

	if (DebugOutput) {printf(" Doing If conditional Order:");}

	if (sIfStack == 255)
	{
		printf("Fatal Error\nIf Stack exceeded\n");
		quitprog();
	}

	sIfStack++;
	sIfDone[sIfStack] = 0;

	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	sIfStack--;

	ArgCount = ArgOld;

	if (DebugOutput) {printf(" If conditional Order ended:");}

	return(progress);
}

int sWhile(unsigned char* script)
{
	int progress, ArgOld;

	if (DebugOutput) {printf(" Doing While Order:");}

	if (sIfStack == 255)
	{
		printf("Fatal Error\nIf Stack exceeded\n");
		quitprog();
	}

	ArgOld = ArgCount;

	sIfStack++;
	sIfDone[sIfStack] = 0;
	sIfApplied[sIfStack] = 1;

	while (sIfApplied[sIfStack])
	{
		sIfApplied[sIfStack] = 0;
		progress = ParseScript(script, 1);
	}
	
	sIfStack--;
	ArgCount = ArgOld;

	if (DebugOutput) {printf(" While Order ended:");}

	return(progress);
}

int SkipScript(unsigned char* script, int num = 1)
{
	int i = 0;

	do
	{
		if (script[i] == 0)
		{
			num--;
			i++;
		}
		else if (script[i] == 1)
		{
			num++;
			i += 5;
		}
		else
		{
			while (script[i] > 1)
			{
				i++;
			}
		}
	}
	while (num);

	return(i);
}

int sIfa(unsigned char* script, int condition)
{
	int ArgOld, progress;
	int DoThis;

	ArgOld = ArgCount;

	if (DebugOutput) {printf(" If block found:");}

	if (sIfDone[sIfStack])
	{
		if (DebugOutput) {printf(" Skipping block:");}
		progress = SkipScript(script);
	}
	else
	{
		progress = ParseScript(script);
		if (condition)
		{
			if (DebugOutput) {printf(" Checking condition:");}
			progress += ParseScript(script + progress);
			DoThis = Args[ArgCount - 1].val;
		}
		else
		{
			if (DebugOutput) {printf(" No condition (Else block):");}
			DoThis = 1;
		}
		ArgCount = ArgOld;

		if (DoThis)
		{
			if (DebugOutput) {printf(" Performing block:");}
			sIfDone[sIfStack] = 1;
			progress += ParseScript(script + progress);
			progress += ParseScript(script + progress);
			progress += SkipScript(script + progress);
			sIfApplied[sIfStack] = 1;
		}
		else
		{
			if (DebugOutput) {printf(" Condition did not aply:");}
			progress += SkipScript(script + progress);
			sIfApplied[sIfStack] = 0;
		}
	}

	if (DebugOutput) {printf(" If block ended:");}

	ArgCount = ArgOld;
	return(progress);
}

int sFor(unsigned char* script)
{
	int progress, ArgOld;
	int pos_condition, pos_increment, pos_order;
	int loopok;

	ArgOld = ArgCount;

	progress = ParseScript(script); //"for("
	progress += ParseScript(script + progress); //valset
	progress += ParseScript(script + progress); //";"

	pos_condition = progress;
	progress += SkipScript(script + progress, 0); //condition

	progress += ParseScript(script + progress); //";"

	pos_increment = progress;
	progress += SkipScript(script + progress, 0); //increment

	progress += ParseScript(script + progress); //"){"

	pos_order = progress;

	do
	{
		ParseScript(script + pos_condition);
		ArgCount--;
		if (Args[ArgCount].val == 1)
		{
			progress = ParseScript(script + pos_order);
			ParseScript(script + pos_increment);
			loopok = 1;
		}
		else
		{
			progress += pos_order + SkipScript(script + pos_order + progress);
			loopok = 0;
		}
	} while (loopok);

	ArgCount = ArgOld;
	return(progress);
}

int ParseScript(unsigned char* script, int depth, char* pThisSymbol)
{
	int i;
	char* pSymbol;
	char DebugTemp[8];

	DebugSpare++;

	i = 0;
	do
	{
		if (script[i] == 0)
		{
			i++;
			depth--;
		}
		else if (script[i] == 1)
		{
			i++;
			pSymbol = (char*) lpSymbolStart + *((int*) &script[i]);
			i += sizeof(int);

			if (DebugOutput)
			{
				sprintf(DebugTemp, "%%%ds", DebugSpare * 2);
				printf("\n");
				printf(DebugTemp, "");
				printf("%4d - %s:", (&script[i] - lpCodeStart - 5), pSymbol);
			}

			if (strcmp(pSymbol, "func_appendtext_a") == 0)
			{
				i += AppendText(&script[i], 0);
			}
			else if (strcmp(pSymbol, "func_appendtext_b") == 0)
			{
				i += AppendText(&script[i], 1);
			}
			else if (strcmp(pSymbol, "func_addfeat_a") == 0)
			{
				i += sAddFeat(&script[i], 1);
			}
			else if (strcmp(pSymbol, "func_addfeat_b") == 0)
			{
				i += sAddFeat(&script[i]);
			}
			else if (strcmp(pSymbol, "func_addfeat_c") == 0)
			{
				i += sAddFeat(&script[i], 1);
			}
			else if (strcmp(pSymbol, "func_featpresent") == 0)
			{
				i += sFeatPresent(&script[i]);
			}
			else if (strcmp(pSymbol, "func_israce") == 0)
			{
				i += sIsRace(&script[i]);
			}
			else if (strcmp(pSymbol, "func_isclass") == 0)
			{
				i += sIsClass(&script[i]);
			}
			else if (strcmp(pSymbol, "func_boostskill") == 0)
			{
				i += BoostSkill(&script[i]);
			}
			else if (strcmp(pSymbol, "func_getskilllevel") == 0)
			{
				i += GetSkillLevel(&script[i]);
			}
			else if (strcmp(pSymbol, "func_getarmortype") == 0)
			{
				i += GetArmorType(&script[i]);
			}
			else if (strcmp(pSymbol, "eval_expression") == 0)
			{
				i += EvalExpr(&script[i]);
			}
			else if (strcmp(pSymbol, "func_max") == 0)
			{
				i += EvalMaxMin(&script[i], 1);
			}
			else if (strcmp(pSymbol, "func_min") == 0)
			{
				i += EvalMaxMin(&script[i], 0);
			}
			else if (strcmp(pSymbol, "variable") == 0)
			{
				i += FetchVar(&script[i], 0);
			}
			else if (strcmp(pSymbol, "variablepointer") == 0)
			{
				i += FetchVar(&script[i], 1);
			}
			else if (strcmp(pSymbol, "valset") == 0)
			{
				i += valset(&script[i]);
			}
			else if (strcmp(pSymbol, "valseta") == 0)
			{
				i += valseta(&script[i]);
			}
			else if (strcmp(pSymbol, "valincrement") == 0)
			{
				i += valincrement(&script[i]);
			}
			else if (strcmp(pSymbol, "condition_all") == 0)
			{
				i += condition_all(&script[i]);
			}
			else if (strcmp(pSymbol, "condition") == 0)
			{
				i += condition(&script[i]);
			}
			else if (strcmp(pSymbol, "if_conditional_order") == 0)
			{
				i += sIf(&script[i]);
			}
			else if (strcmp(pSymbol, "while_structure") == 0)
			{
				i += sWhile(&script[i]);
			}
			else if (strcmp(pSymbol, "for_structure") == 0)
			{
				i += sFor(&script[i]);
			}
			else if (strcmp(pSymbol, "if_block") == 0)
			{
				i += sIfa(&script[i], 1);
			}
			else if (strcmp(pSymbol, "else_block") == 0)
			{
				i += sIfa(&script[i], 0);
			}
			else
			{
				i += ParseScript(&script[i], 1, pSymbol);
			}
		}
		else
		{
			char CharOut[2] = " ";
			while (script[i] > 1)
			{
				CharOut[0] = script[i];
				if (DebugOutput) {printf("%s", CharOut);}
				i++;
			}
		}
	} while (depth > 0);

	if (strcmp(pThisSymbol, "string") == 0)
	{
		Args[ArgCount].type = 1;
		Args[ArgCount].val = (int) (script);
		ArgCount++;
	}

	if (strcmp(pThisSymbol, "identifier") == 0)
	{
		Args[ArgCount].type = 1;
		Args[ArgCount].val = (int) (script);
		ArgCount++;
	}

	if (strcmp(pThisSymbol, "compare_operator") == 0)
	{
		Args[ArgCount].type = 1;
		Args[ArgCount].val = (int) (script);
		ArgCount++;
	}

	if (strcmp(pThisSymbol, "condition_link") == 0)
	{
		Args[ArgCount].type = 0;
		Args[ArgCount].val = (int) (*script);
		ArgCount++;
	}

	if (strcmp(pThisSymbol, "setting_operator") == 0)
	{
		Args[ArgCount].type = 1;
		Args[ArgCount].val = (int) (script);
		ArgCount++;
	}
	
	if (strcmp(pThisSymbol, "increment_operator") == 0)
	{
		Args[ArgCount].type = 1;
		Args[ArgCount].val = (int) (script);
		ArgCount++;
	}

	if (strcmp(pThisSymbol, "val") == 0)
	{
		Args[ArgCount].type = 0;
		LockString(script);
		sscanf((char*) script, "%d", &Args[ArgCount].val);
		ReleaseString(script);
		ArgCount++;
	}

	if (strcmp(pThisSymbol, "operator") == 0)
	{
		Args[ArgCount].type = 0;
		Args[ArgCount].val = (int) *(script);
		ArgCount++;
	}

	DebugSpare--;

	return(i);
}

int RunScript(clsChar* TargetStruct, clsEquip* TargetStructE, char* TextOutput, char* script)
{
	lpCodeStart = (unsigned char*) script;
	lpSymbolStart = bnf::SymbolNames;

	pCurChar = TargetStruct;
	pCurEquip = TargetStructE;
	pCurText = TextOutput;

	return(ParseScript(lpCodeStart));
}